<?php
//-------------------------------------------------------------------------
// OVIDENTIA http://www.ovidentia.org
// Ovidentia is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
// 
// This program is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
// See the GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
// USA.
//-------------------------------------------------------------------------
/**
 * @license http://opensource.org/licenses/gpl-license.php GNU General Public License (GPL)
 * @copyright Copyright (c) 2006 by CANTICO ({@link http://www.cantico.fr})
 */
require_once 'base.php';
require_once dirname(__FILE__).'/functions.php';
require_once $GLOBALS['babInstallPath'].'utilit/urlincl.php';





class editlinks_optionsTemplate
{
	public function getHtml()
	{
		$this->t_topic 					= editlinks_translate('Use editlinks on the topic page');
		$this->t_readmore 				= editlinks_translate('Use editlinks on the readmore page');
		
		$this->t_save					= editlinks_translate('Save');
		
		$registry = bab_getRegistryInstance();
		$registry->changeDirectory('/editlinks/');
		
		$this->topic 				= $registry->getValue('topic'				, false);
		$this->readmore				= $registry->getValue('readmore'			, false);

		return bab_printTemplate($this, $GLOBALS['babAddonHtmlPath'].'admin.html', 'options');
	}
}







function editlinks_saveConfiguration()
{
	
	global $babBody;
	
	$registry = bab_getRegistryInstance();
	$registry->changeDirectory('/editlinks/');

	
	$registry->setKeyValue('topic', (bool) bab_pp('topic'));
	$registry->setKeyValue('readmore', (bool) bab_pp('readmore'));

	
	$url = bab_url::get_request('tg');
	$url->location();
}




function editlinks_options()
{
	if (!empty($_POST))
	{
		editlinks_saveConfiguration();
	}
	
	global $babBody;
	
	$template = new editlinks_optionsTemplate;
	
	$babBody->babEcho($template->getHtml());
}



// 

if (!bab_isUserAdministrator())
{
	return;
}


editlinks_options();

