<?php
//-------------------------------------------------------------------------
// OVIDENTIA http://www.ovidentia.org
// Ovidentia is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
//
// This program is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
// See the GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
// USA.
//-------------------------------------------------------------------------
/**
 * @license http://opensource.org/licenses/gpl-license.php GNU General Public License (GPL)
 * @copyright Copyright (c) 2011 by CANTICO ({@link http://www.cantico.fr})
 */

require_once $GLOBALS['babInstallPath'].'utilit/utilit.php';


/**
 * @param string|array $string
 * @return string|array
 */
function widgets_recursiveConvertToDatabaseEncoding($string)
{
    if (!is_array($string)) {
        return bab_convertToDatabaseEncoding($string);
    }
    foreach ($string as $k => $v) {
        $string[$k] = widgets_recursiveConvertToDatabaseEncoding($v);
    }
    return $string;
}


/* @var $W Func_Widgets */
$W = bab_functionality::get('Widgets');

$idx = bab_rp('idx', null);

switch ($idx) {

    case 'table':
        $key = bab_rp('key', null);
        if (isset($key)) {
            $addon = bab_rp('addon', 'widgets');
            $sessionOnly = (bool)bab_rp('insession', true);
            foreach ($_GET as $name => $value) {
                if (is_array($value) && isset($value['filter'])) {
                    $W->setUserConfiguration($key . '/filter', widgets_recursiveConvertToDatabaseEncoding($value['filter']), $addon, $sessionOnly);
                }
                if ($name === 'filter') {
                    $W->setUserConfiguration($key . '/filter', widgets_recursiveConvertToDatabaseEncoding($value), $addon, $sessionOnly);
                }
                if ($name === 'page') {
                    $W->setUserConfiguration($key . '/page', $value, $addon, $sessionOnly);
                }
                if ($name === 'pageLength') {
                    $W->setUserConfiguration($key . '/pageLength', $value, $addon, $sessionOnly);
                }
                if ($name === 'sort') {
                    $W->setUserConfiguration($key . '/sort', $value, $addon, $sessionOnly);
                }
            }
        }
        break;

    case 'delete':
        $path = bab_rp('path', null);
        $addon = bab_rp('addon', 'widgets');
        if (isset($path)) {
            $W->deleteUserConfiguration($path, $addon);
        }
        break;

    case 'set':
    default:
        $key = bab_rp('key', null);
        $value = bab_rp('value', null);
        $addon = bab_rp('addon', 'widgets');
        if (isset($key) && isset($value)) {
            $W->setUserConfiguration($key, $value, $addon);
        }
        break;
}

die;
